/* Tabela CONTCORR: */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na coluna:
              Conta contabil: CDCONTCTBL */
/* Objetivo: Gerar um log que vai registrar na tabela Geral de Logs de Operaes as alteraes nos campos da tabela Produto listados  seguir:
            Conta contabil: CDCONTCTBL */
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_CONTCORR'   AND
                 TYPE   = 'TR'                AND
                 U.UID  = O.UID               AND
                 U.NAME = USER)
DROP TRIGGER LOG_GER_CONTCORR
GO
CREATE TRIGGER LOG_GER_CONTCORR
ON CONTCORR
FOR DELETE, INSERT, UPDATE
AS

  DECLARE @V_DSREMOTEADDR VARCHAR(15);
  DECLARE @V_DSREMOTEHOST VARCHAR(15);
  DECLARE @V_DSSERVERRDM  VARCHAR(20);
  DECLARE @V_DSSERVMETHOD VARCHAR(30);
  DECLARE @V_DSREMOTEOPER VARCHAR(12);
  DECLARE @V_DESC         VARCHAR(500);
  DECLARE @V_ITPESQ       VARCHAR(40);
  DECLARE @V_NMOPERADOR   VARCHAR(40);
  DECLARE @V_IDTIPOOPER   VARCHAR(1);
/*VARIVEIS DO CURSOR C_CURSOR*/
  DECLARE @V_IDCOMANDO      VARCHAR(1);
  DECLARE @V_OLD_CDBANCO    VARCHAR(3);
  DECLARE @V_OLD_CDAGENCIA  VARCHAR(5);
  DECLARE @V_OLD_CDCONTCORR VARCHAR(10);
  DECLARE @V_OLD_CDCONTCTBL VARCHAR(20);
  DECLARE @V_OLD_CDREDUCONT VARCHAR(20);
  DECLARE @V_NEW_CDBANCO    VARCHAR(3);
  DECLARE @V_NEW_CDAGENCIA  VARCHAR(5);
  DECLARE @V_NEW_CDCONTCORR VARCHAR(10);
  DECLARE @V_NEW_CDCONTCTBL VARCHAR(20);
  DECLARE @V_NEW_CDREDUCONT VARCHAR(20);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   SET @V_DESC       = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';
   EXEC NMUSUARIO @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
              @V_DSREMOTEHOST,
              @V_DSSERVERRDM,
              @V_DSSERVMETHOD,
              @V_DSREMOTEOPER;
   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         CDBANCO,
         CDAGENCIA,
         CDCONTCORR,
         CDCONTCTBL,
	 CDREDUCONT,
         NULL,
         NULL,
         NULL,
         NULL,
	 NULL
      FROM
         DELETED
      WHERE
         CDBANCO+CDAGENCIA+CDCONTCORR+CDCONTCTBL+CDREDUCONT NOT IN (SELECT CDBANCO+CDAGENCIA+CDCONTCORR+CDCONTCTBL+CDREDUCONT
							  FROM INSERTED)

      UNION ALL
      SELECT
         'U' IDCOMANDO,
         DELETED.CDBANCO,
         DELETED.CDAGENCIA,
         DELETED.CDCONTCORR,
         DELETED.CDCONTCTBL,
	 DELETED.CDREDUCONT,
         INSERTED.CDBANCO,
         INSERTED.CDAGENCIA,
         INSERTED.CDCONTCORR,
         INSERTED.CDCONTCTBL,
	 INSERTED.CDREDUCONT
      FROM
         INSERTED,
         DELETED
      WHERE
         DELETED.CDBANCO = INSERTED.CDBANCO AND
         DELETED.CDAGENCIA = INSERTED.CDAGENCIA AND
         DELETED.CDCONTCORR = INSERTED.CDCONTCORR AND
         DELETED.CDCONTCTBL = INSERTED.CDCONTCTBL AND
         DELETED.CDREDUCONT = INSERTED.CDREDUCONT

      UNION ALL
      SELECT
         'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
	 NULL,
         CDBANCO,
         CDAGENCIA,
         CDCONTCORR,
         CDCONTCTBL,
	 CDREDUCONT
      FROM
         INSERTED
      WHERE
         CDBANCO+CDAGENCIA+CDCONTCORR+CDCONTCTBL+CDREDUCONT NOT IN (SELECT CDBANCO+CDAGENCIA+CDCONTCORR+CDCONTCTBL+CDREDUCONT
							 FROM DELETED);

      OPEN C_CURSOR;
      FETCH NEXT FROM C_CURSOR INTO @V_IDCOMANDO,
				    @V_OLD_CDBANCO,
				    @V_OLD_CDAGENCIA,
				    @V_OLD_CDCONTCORR,
				    @V_OLD_CDCONTCTBL,
				    @V_OLD_CDREDUCONT,
				    @V_NEW_CDBANCO,
				    @V_NEW_CDAGENCIA,
				    @V_NEW_CDCONTCORR,
				    @V_NEW_CDCONTCTBL,
				    @V_NEW_CDREDUCONT;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF @V_IDCOMANDO = 'D' BEGIN
            SET @V_IDTIPOOPER   = '3';
            SET @V_DESC         =    'Banco '   + '' + ISNULL(@V_OLD_CDBANCO,'')+' '+
                                     'Agencia ' + '' + ISNULL(@V_OLD_CDAGENCIA,'')+' '+
                                     'ContCorr '+ '' + ISNULL(@V_OLD_CDCONTCORR,'')+' '+
                                     'ContCont '+ '' + ISNULL(@V_OLD_CDCONTCTBL,'');
            SET @V_ITPESQ       = @V_OLD_CDREDUCONT;
	 END
         ELSE BEGIN
            IF @V_IDCOMANDO = 'U' BEGIN
                SET @V_DESC         = 'Banco '   + '' + ISNULL(@V_NEW_CDBANCO,'')+' '+
                                      'Agencia ' + '' + ISNULL(@V_NEW_CDAGENCIA,'')+' '+
                                      'ContCorr '+ '' + ISNULL(@V_NEW_CDCONTCORR,'')+' '+
                                      'ContCont '+ '' + ISNULL(@V_NEW_CDCONTCTBL,'');
                SET @V_ITPESQ = @V_NEW_CDREDUCONT;
                SET @V_IDTIPOOPER = '2';
	    END
            ELSE BEGIN
               SET @V_IDTIPOOPER   = '1';
               SET @V_ITPESQ       = @V_NEW_CDREDUCONT;
               SET @V_DESC         = 'Banco '   + '' + ISNULL(@V_NEW_CDBANCO,'')+' '+
                                     'Agencia ' + '' + ISNULL(@V_NEW_CDAGENCIA,'')+' '+
                                     'ContCorr '+ '' + ISNULL(@V_NEW_CDCONTCORR,'')+' '+
                                     'ContCont '+ '' + ISNULL(@V_NEW_CDCONTCTBL,'');
            END;
         END;
         SET @V_DESC = SUBSTRING(@V_DESC, 1, 300);
         INSERT INTO LOGOPERA
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM,
          DSRDMUSUOPER,
          DSENDUSUOPER,
          DSNMUSUOPER,
          DSMETUSUOPER,
          CDORESPOPER)
         VALUES
         ('CONTCORR',
          GETDATE(),
          ISNULL(@V_NMOPERADOR,' '),
          @V_IDTIPOOPER,
          @V_DESC,
          @V_ITPESQ,
          @V_DSSERVERRDM,
          @V_DSREMOTEADDR,
          @V_DSREMOTEHOST,
          @V_DSSERVMETHOD,
          @V_DSREMOTEOPER);
	  FETCH NEXT FROM C_CURSOR INTO @V_IDCOMANDO,
				    @V_OLD_CDBANCO,
				    @V_OLD_CDAGENCIA,
				    @V_OLD_CDCONTCORR,
				    @V_OLD_CDCONTCTBL,
				    @V_OLD_CDREDUCONT,
				    @V_NEW_CDBANCO,
				    @V_NEW_CDAGENCIA,
				    @V_NEW_CDCONTCORR,
				    @V_NEW_CDCONTCTBL,
				    @V_NEW_CDREDUCONT;
     END;
     CLOSE C_CURSOR;
     DEALLOCATE C_CURSOR;
END;
GO