/*RAISERROR(@P_CDOPERADOR+'-'+@P_CDFILIAL,16,1);*/
IF EXISTS (SELECT
              *
           FROM
              SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'PREPARA_ORCAMENTO' AND
              TYPE = 'P' 		            AND
              U.UID = O.UID               AND
              U.NAME = USER)

DROP PROCEDURE PREPARA_ORCAMENTO
GO


CREATE PROCEDURE PREPARA_ORCAMENTO
                    @P_NRANOORCAOP     VARCHAR(20),
                    @P_CDOPERADOR      VARCHAR(2000),
                    @P_CDFILIAL        VARCHAR(2000),
                    @P_IDEXCLUI        VARCHAR(2) = 'N',
                    @P_LISTAOPER       VARCHAR(2) = 'N',
                    @P_LISTAFIL        VARCHAR(2) = 'N'
AS
   DECLARE @V_NRITEMORCA      VARCHAR(10);
   DECLARE @V_FILIALPAR       VARCHAR(4);   /*Filial padro*/
   DECLARE @V_CDFILCENTPME    VARCHAR(4);
   DECLARE @V_IDFATUROP       VARCHAR(2);
   DECLARE @V_IDSERVFATROP    CHAR;
   DECLARE @V_IDFILIALAGRROP  CHAR;
   DECLARE @V_IDUTPADRROPFIL  CHAR;
   DECLARE @V_IDUTPADRROP     CHAR;
   DECLARE @V_CDFILIAL        VARCHAR(4);
   DECLARE @V_CDDESPADMFAT    VARCHAR(10);
   DECLARE @V_CDDESPPREV      VARCHAR(10);
   DECLARE @V_CDTIPOOPER      VARCHAR(2);
   DECLARE @V_CDLISTA         VARCHAR(4);
BEGIN

   IF @P_IDEXCLUI = 'S' BEGIN

      DECLARE C_DELETA  CURSOR FOR
                 SELECT CDLISTA
                   FROM LISTA
                  WHERE NRLISTA = @P_CDFILIAL;


      OPEN C_DELETA;
      FETCH NEXT FROM C_DELETA INTO  @V_CDLISTA;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         DELETE FROM APROVAORCAOP
          WHERE NRANOORCAOP = @P_NRANOORCAOP
            AND IDAPROVACAOOP <> 'A'
            AND CDFILIAL      = @V_CDLISTA;

         DELETE FROM ORCAMENTOOP
         WHERE NRANOORCAOP = @P_NRANOORCAOP
           AND IDSTATUSORCA <> 'E'
           AND CDFILIAL     = @V_CDLISTA;

         FETCH NEXT FROM C_DELETA INTO  @V_CDLISTA;
      END;
      CLOSE C_DELETA;
      DEALLOCATE C_DELETA;

   END;

   SELECT @V_IDUTPADRROP = MAX(IDUTPADRROP)
   FROM PARAMGERAL G;

   IF (@P_LISTAOPER = 'S') AND (@P_LISTAFIL = 'S') BEGIN

      INSERT INTO ORCAMENTOOP
       (NRANOORCAOP, CDFILIAL, CDOPERADOR, DTORCAMENTO, IDSTATUSORCA)
      (SELECT DISTINCT @P_NRANOORCAOP, CDFILIAL, FO.CDOPERADOR, GETDATE(), 'P'
         FROM FILIALOPEROP FO, LISTA O, LISTA F
        WHERE O.NRLISTA       = @P_CDOPERADOR
          AND F.NRLISTA       = @P_CDFILIAL
          AND FO.CDFILIAL     = F.CDLISTA
          AND FO.CDOPERADOR   = O.CDLISTA
          AND FO.IDACESSOCALC = 'S'
          AND
          NOT EXISTS

       (SELECT DISTINCT @P_NRANOORCAOP, CDFILIAL, O.CDOPERADOR, GETDATE(), 'P'
         FROM ORCAMENTOOP P, OPERADOR O
        WHERE NRANOORCAOP = @P_NRANOORCAOP
          AND O.CDOPERADOR = FO.CDOPERADOR
          AND P.CDFILIAL   = FO.CDFILIAL));

   END
   ELSE BEGIN
      IF (@P_LISTAOPER = 'S') AND (ISNULL(@P_LISTAFIL,'S') = 'N') BEGIN
         INSERT INTO ORCAMENTOOP
          (NRANOORCAOP, CDFILIAL, CDOPERADOR, DTORCAMENTO, IDSTATUSORCA)
         (SELECT DISTINCT @P_NRANOORCAOP, CDFILIAL, FO.CDOPERADOR, GETDATE(), 'P'
            FROM FILIALOPEROP FO, LISTA O
           WHERE O.NRLISTA       = @P_CDOPERADOR
             AND FO.CDOPERADOR   = O.CDLISTA
             AND FO.IDACESSOCALC = 'S'
             AND
           NOT EXISTS
          (SELECT DISTINCT @P_NRANOORCAOP, CDFILIAL, O.CDOPERADOR, GETDATE(), 'P'
            FROM ORCAMENTOOP, OPERADOR O
           WHERE NRANOORCAOP = @P_NRANOORCAOP));
      END
      ELSE BEGIN
         IF (@P_LISTAOPER = 'N') AND (ISNULL(@P_LISTAFIL,'S') = 'S') BEGIN

            INSERT INTO ORCAMENTOOP
             (NRANOORCAOP, CDFILIAL, CDOPERADOR, DTORCAMENTO, IDSTATUSORCA)
            (SELECT DISTINCT @P_NRANOORCAOP, CDFILIAL, FO.CDOPERADOR, GETDATE(), 'P'
               FROM FILIALOPEROP FO, LISTA F
              WHERE F.NRLISTA       = @P_CDFILIAL
                AND FO.CDFILIAL     = F.CDLISTA
                AND FO.IDACESSOCALC = 'S'
                AND FO.CDOPERADOR   = @P_CDOPERADOR
                AND
              NOT EXISTS
             (SELECT DISTINCT @P_NRANOORCAOP, CDFILIAL, O.CDOPERADOR, GETDATE(), 'P'
               FROM ORCAMENTOOP, OPERADOR O
              WHERE NRANOORCAOP = @P_NRANOORCAOP));
         END
         ELSE BEGIN
            INSERT INTO ORCAMENTOOP
             (NRANOORCAOP, CDFILIAL, CDOPERADOR, DTORCAMENTO, IDSTATUSORCA)
            (SELECT DISTINCT @P_NRANOORCAOP, CDFILIAL, FO.CDOPERADOR, GETDATE(), 'P'
               FROM FILIALOPEROP FO
              WHERE FO.IDACESSOCALC = 'S'
                AND FO.CDOPERADOR   = @P_CDOPERADOR
                AND
                NOT EXISTS

             (SELECT DISTINCT @P_NRANOORCAOP, CDFILIAL, O.CDOPERADOR, GETDATE(), 'P'
               FROM ORCAMENTOOP, OPERADOR O
              WHERE NRANOORCAOP = @P_NRANOORCAOP));
         END;
      END;
   END;

   DECLARE C_FILIAL CURSOR FOR
      SELECT O.CDFILIAL
        FROM ORCAMENTOOP O
        WHERE NRANOORCAOP = @P_NRANOORCAOP;

   OPEN C_FILIAL;
   FETCH NEXT FROM C_FILIAL INTO  @V_CDFILIAL;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF (@V_IDUTPADRROP = 'S') BEGIN
         SET @V_FILIALPAR = 'P';
      END
      ELSE BEGIN
         SELECT @V_IDUTPADRROPFIL = MAX(IDUTPADRROPFIL),
                @V_CDFILCENTPME = MAX(CDFILCENTPME)
         FROM FILIAL F LEFT JOIN PARFILIALROP P ON
                              F.CDFILIAL = P.CDFILIAL
         WHERE
            F.CDFILIAL    = @V_CDFILIAL;

         IF (@V_IDUTPADRROPFIL = 'S') BEGIN
            SET @V_FILIALPAR = 'P';
         END
         ELSE BEGIN
            IF @V_CDFILCENTPME IS NULL BEGIN
               SET @V_FILIALPAR = @V_CDFILIAL;
            END
            ELSE BEGIN
               SELECT @V_IDFILIALAGRROP = MAX(IDFILIALAGRROP)
               FROM PARFILIALROP
               WHERE CDFILIAL = @V_CDFILCENTPME;

               IF @V_IDFILIALAGRROP = 'S' BEGIN
                  SET @V_FILIALPAR = @V_CDFILCENTPME;
               END
               ELSE BEGIN
                  SET @V_FILIALPAR = @V_CDFILIAL;
               END;
            END;
         END;
      END;

      SELECT @V_IDFATUROP = MAX(IDFATUROP),
             @V_IDSERVFATROP = MAX(IDSERVFATROP)
      FROM PARFILIALROP P
      WHERE P.CDFILIAL = @V_FILIALPAR;


      SELECT @V_NRITEMORCA = RIGHT((REPLICATE('0', '10') +CONVERT(VARCHAR,(CONVERT(NUMERIC,ISNULL(MAX(NRSEQITEMORCA),'0'))+1))), 10)
        FROM ITEMORCAOP
       WHERE CDFILIAL   = @V_CDFILIAL
         AND NRANOORCAOP = @P_NRANOORCAOP;


      INSERT INTO ITEMORCAOP
         (NRANOORCAOP, CDFILIAL, NRSEQITEMORCA, IDENTRSAIDOP, CDTIPOOPER, CDDESPADMFAT, CDDESPPREV,
          DTORCAMENTOITEM, IDTIPOORCAOP, IDITEMORCAMENTO)
        (SELECT  @P_NRANOORCAOP, @V_CDFILIAL, @V_NRITEMORCA, NULL,NULL, NULL,NULL,GETDATE(), 'F','P'
         FROM PARAMGERAL
         WHERE
         NOT EXISTS
         (SELECT @P_NRANOORCAOP, @V_CDFILIAL, @V_NRITEMORCA, NULL,NULL, NULL, NULL,GETDATE(), 'F','P'
         FROM ITEMORCAOP
         WHERE NRANOORCAOP = @P_NRANOORCAOP
           AND CDFILIAL = @V_CDFILIAL
           AND IDTIPOORCAOP = 'F'));

      SET @V_NRITEMORCA =  RIGHT((REPLICATE('0', '10') +CONVERT(VARCHAR,(CONVERT(NUMERIC,ISNULL(MAX(@V_NRITEMORCA),'0'))+1))), 10);


      INSERT INTO ITEMORCAOP
         (NRANOORCAOP, CDFILIAL, NRSEQITEMORCA, IDENTRSAIDOP, CDTIPOOPER, CDDESPADMFAT, CDDESPPREV,
          DTORCAMENTOITEM, IDTIPOORCAOP, IDITEMORCAMENTO)
        (SELECT  @P_NRANOORCAOP, @V_CDFILIAL, @V_NRITEMORCA, NULL,NULL, NULL, NULL,GETDATE(), 'C','P'
         FROM PARAMGERAL
         WHERE
         NOT EXISTS
         (SELECT @P_NRANOORCAOP, @V_CDFILIAL, @V_NRITEMORCA, NULL,NULL, NULL, NULL,GETDATE(), 'C','P'
         FROM ITEMORCAOP
         WHERE NRANOORCAOP = @P_NRANOORCAOP
           AND CDFILIAL = @V_CDFILIAL
           AND IDTIPOORCAOP = 'C'));

      SET @V_NRITEMORCA = RIGHT((REPLICATE('0', '10') +CONVERT(VARCHAR,(CONVERT(NUMERIC,ISNULL(MAX(@V_NRITEMORCA),'0'))+1))), 10);

      DECLARE C_MAOOBRA CURSOR FOR
         SELECT  CDDESPADMFAT
           FROM DESPADMFATUR
          WHERE

          NOT EXISTS

         (SELECT CDDESPADMFAT
         FROM ITEMORCAOP
         WHERE NRANOORCAOP = @P_NRANOORCAOP
           AND CDFILIAL = @V_CDFILIAL
           AND IDTIPOORCAOP = 'O');

      OPEN C_MAOOBRA;
      FETCH NEXT FROM C_MAOOBRA INTO  @V_CDDESPADMFAT;
      WHILE (@@FETCH_STATUS = 0) BEGIN

        SET @V_NRITEMORCA = RIGHT((REPLICATE('0', '10') +CONVERT(VARCHAR,(CONVERT(NUMERIC,ISNULL(MAX(@V_NRITEMORCA),'0'))+1))), 10);

        INSERT INTO ITEMORCAOP
           (NRANOORCAOP, CDFILIAL, NRSEQITEMORCA, IDENTRSAIDOP, CDTIPOOPER, CDDESPADMFAT,CDDESPPREV,
            DTORCAMENTOITEM, IDTIPOORCAOP, IDITEMORCAMENTO)
        VALUES
           (@P_NRANOORCAOP, @V_CDFILIAL, @V_NRITEMORCA, NULL,NULL, @V_CDDESPADMFAT,NULL,GETDATE(), 'O','P');

         FETCH NEXT FROM C_MAOOBRA INTO  @V_CDDESPADMFAT;
      END;

      CLOSE C_MAOOBRA;
      DEALLOCATE C_MAOOBRA;


      DECLARE C_DIVERSAS CURSOR FOR
         SELECT  CDDESPPREV
           FROM DESPPREV
          WHERE IDDESPESAMATRIZ <> 'S'
          AND
           NOT EXISTS
           (SELECT CDDESPPREV
           FROM ITEMORCAOP
           WHERE NRANOORCAOP = @P_NRANOORCAOP
             AND CDFILIAL = @V_CDFILIAL
             AND IDTIPOORCAOP = 'D');

      OPEN C_DIVERSAS;
      FETCH NEXT FROM C_DIVERSAS INTO  @V_CDDESPPREV;

      WHILE (@@FETCH_STATUS = 0) BEGIN

        SET @V_NRITEMORCA =  RIGHT((REPLICATE('0', '10') +CONVERT(VARCHAR,(CONVERT(NUMERIC,ISNULL(MAX(@V_NRITEMORCA),'0'))+1))), 10);


        INSERT INTO ITEMORCAOP
           (NRANOORCAOP, CDFILIAL, NRSEQITEMORCA, IDENTRSAIDOP, CDTIPOOPER, CDDESPADMFAT, CDDESPPREV,
            DTORCAMENTOITEM, IDTIPOORCAOP, IDITEMORCAMENTO)
        VALUES
           (@P_NRANOORCAOP, @V_CDFILIAL, @V_NRITEMORCA, NULL,NULL, NULL, @V_CDDESPPREV,GETDATE(), 'D','P');
         FETCH NEXT FROM C_DIVERSAS INTO  @V_CDDESPPREV;
      END;
      CLOSE C_DIVERSAS;
      DEALLOCATE C_DIVERSAS;


      DECLARE C_MATRIZ CURSOR FOR
         SELECT  CDDESPPREV
           FROM DESPPREV
        WHERE IDDESPESAMATRIZ = 'S' AND
           NOT EXISTS
           (SELECT CDDESPPREV
           FROM ITEMORCAOP
           WHERE NRANOORCAOP = @P_NRANOORCAOP
             AND CDFILIAL = @V_CDFILIAL
             AND IDTIPOORCAOP = 'M');

      OPEN C_MATRIZ;
      FETCH NEXT FROM C_MATRIZ INTO  @V_CDDESPPREV;

      WHILE (@@FETCH_STATUS = 0) BEGIN

        SET @V_NRITEMORCA = RIGHT((REPLICATE('0', '10') +CONVERT(VARCHAR,(CONVERT(NUMERIC,ISNULL(MAX(@V_NRITEMORCA),'0'))+1))), 10);


        INSERT INTO ITEMORCAOP
           (NRANOORCAOP, CDFILIAL, NRSEQITEMORCA, IDENTRSAIDOP, CDTIPOOPER, CDDESPADMFAT, CDDESPPREV,
            DTORCAMENTOITEM, IDTIPOORCAOP, IDITEMORCAMENTO)
        VALUES
           (@P_NRANOORCAOP, @V_CDFILIAL, @V_NRITEMORCA, NULL,NULL, NULL, @V_CDDESPPREV,GETDATE(), 'M','P');
         FETCH NEXT FROM C_MATRIZ INTO  @V_CDDESPPREV;
      END;
      CLOSE C_MATRIZ;
      DEALLOCATE C_MATRIZ;

      DECLARE C_ENTRADAS CURSOR FOR
         SELECT CDTIPOOPER
           FROM TIPOOPERACROP
           WHERE IDTPOPERACROP = 'DE'
             AND IDENTRSAIDOP = 'E'
             AND CDFILIAL = @V_FILIALPAR
             AND
           NOT EXISTS
           (SELECT CDTIPOOPER
            FROM ITEMORCAOP
            WHERE NRANOORCAOP = @P_NRANOORCAOP
              AND CDFILIAL = @V_CDFILIAL
              AND IDTIPOORCAOP = 'E'
              AND IDENTRSAIDOP = 'E');

      OPEN C_ENTRADAS;
      FETCH NEXT FROM C_ENTRADAS INTO  @V_CDTIPOOPER;

      WHILE (@@FETCH_STATUS = 0) BEGIN

        SET @V_NRITEMORCA = RIGHT((REPLICATE('0', '10') +CONVERT(VARCHAR,(CONVERT(NUMERIC,ISNULL(MAX(@V_NRITEMORCA),'0'))+1))), 10);

        INSERT INTO ITEMORCAOP
           (NRANOORCAOP, CDFILIAL, NRSEQITEMORCA, IDENTRSAIDOP, CDTIPOOPER, CDDESPADMFAT, CDDESPPREV,
            DTORCAMENTOITEM, IDTIPOORCAOP, IDITEMORCAMENTO)
        VALUES
           (@P_NRANOORCAOP, @V_CDFILIAL, @V_NRITEMORCA, 'E',@V_CDTIPOOPER, NULL,NULL,GETDATE(), 'E','P');

         FETCH NEXT FROM C_ENTRADAS INTO  @V_CDTIPOOPER;
      END;
      CLOSE C_ENTRADAS ;
      DEALLOCATE C_ENTRADAS;


      IF (@P_LISTAOPER = 'S') AND (@P_LISTAFIL = 'S') BEGIN
         INSERT INTO APROVAORCAOP(NRANOORCAOP, CDFILIAL, CDOPERADOR, IDAPROVACAOOP)
            (SELECT DISTINCT @P_NRANOORCAOP, CDFILIAL, FO.CDOPERADOR, 'P'
               FROM FILIALOPEROP FO, LISTA O, LISTA F
              WHERE O.NRLISTA       = @P_CDOPERADOR
                AND F.NRLISTA       = @P_CDFILIAL
                AND FO.CDFILIAL     = @V_CDFILIAL
                AND FO.CDFILIAL     = F.CDLISTA
                AND FO.CDOPERADOR   = O.CDLISTA
                AND FO.IDACESSOCALC = 'S'
                AND
             NOT EXISTS
             (SELECT NRANOORCAOP, CDFILIAL, CDOPERADOR,'P'
             FROM APROVAORCAOP
             WHERE CDFILIAL = @V_CDFILIAL
               AND NRANOORCAOP = @P_NRANOORCAOP));
      END
      ELSE BEGIN
         IF (@P_LISTAOPER = 'S') AND (ISNULL(@P_LISTAFIL,'S') = 'N') BEGIN
            INSERT INTO APROVAORCAOP(NRANOORCAOP, CDFILIAL, CDOPERADOR, IDAPROVACAOOP)
               (SELECT DISTINCT @P_NRANOORCAOP, CDFILIAL, FO.CDOPERADOR, 'P'
                  FROM FILIALOPEROP FO, LISTA O
                 WHERE O.NRLISTA       = @P_CDOPERADOR
                   AND FO.CDOPERADOR   = O.CDLISTA
                   AND FO.CDFILIAL     = @V_CDFILIAL
                   AND FO.IDACESSOCALC = 'S'
                   AND
                NOT EXISTS
                (SELECT NRANOORCAOP, CDFILIAL, CDOPERADOR,'P'
                FROM APROVAORCAOP
                WHERE CDFILIAL = @V_CDFILIAL
                  AND NRANOORCAOP = @P_NRANOORCAOP));
         END  
         ELSE BEGIN
            IF (@P_LISTAOPER = 'N') AND (ISNULL(@P_LISTAFIL,'S') = 'S') BEGIN
           INSERT INTO APROVAORCAOP(NRANOORCAOP, CDFILIAL, CDOPERADOR, IDAPROVACAOOP)
            (SELECT DISTINCT @P_NRANOORCAOP, CDFILIAL, FO.CDOPERADOR, 'P'
                  FROM FILIALOPEROP FO, LISTA F
                 WHERE F.NRLISTA       = @P_CDFILIAL
                   AND FO.CDFILIAL     = F.CDLISTA
                   AND FO.CDFILIAL     = @V_CDFILIAL
                   AND FO.IDACESSOCALC = 'S'
                   AND FO.CDOPERADOR   = @P_CDOPERADOR
                   AND
                NOT EXISTS
                (SELECT NRANOORCAOP, CDFILIAL, CDOPERADOR,'P'
                FROM APROVAORCAOP
                WHERE CDFILIAL = @V_CDFILIAL
                  AND NRANOORCAOP = @P_NRANOORCAOP));
            END
            ELSE BEGIN
              INSERT INTO APROVAORCAOP(NRANOORCAOP, CDFILIAL, CDOPERADOR, IDAPROVACAOOP)
               (SELECT DISTINCT @P_NRANOORCAOP, CDFILIAL, FO.CDOPERADOR, 'P'
                  FROM FILIALOPEROP FO
                 WHERE FO.IDACESSOCALC = 'S'
                   AND FO.CDFILIAL     = @V_CDFILIAL
                   AND
                 NOT EXISTS
                (SELECT NRANOORCAOP, CDFILIAL, CDOPERADOR,'P'
                FROM APROVAORCAOP
                WHERE CDFILIAL = @V_CDFILIAL
                  AND NRANOORCAOP = @P_NRANOORCAOP));
            END;
         END;
      END;
      FETCH NEXT FROM C_FILIAL INTO  @V_CDFILIAL;
   END;
   CLOSE C_FILIAL;
   DEALLOCATE C_FILIAL;
END;

GO
-- VERSAO --
EXEC ATUVEROBJ 'PREPARA_ORCAMENTO','5.09.000';

GO
